/*	miniscanner3d.c v 0.1
 *	maggio 2005
 *	Copyright (C) 2005  Spezia Raffaele Antonio
 *	lele.sra@axefactory.com
 *	
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    For a copy of the GNU General Public License
    , write to the Free Software
    Foundation, 
    51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA


 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 
 

 */

#include <asm/io.h>
#define BASEPORT 0x378 /* lp1 */
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <signal.h>
#include <sys/wait.h>
#include <linux/videodev.h>

#include <errno.h>
#include <fcntl.h>
#define SOGLIA_r 245
#define SOGLIA_g 251
#define SOGLIA_b 251
#define DIFFERENZA 30

int fmt=VIDEO_PALETTE_RGB24;

int read_img=0;

unsigned int matrice[400][600] ;





char *start_capture (unsigned int dev,unsigned int width,unsigned int height)
{
        struct video_capability vid_caps;
	struct video_window vid_win;
	struct video_mbuf vid_buf;
	unsigned char *map;

	if (ioctl (dev, VIDIOCGCAP, &vid_caps) == -1) {
		perror ("ioctl (VIDIOCGCAP)");
		return (NULL);
	}
	if (vid_caps.type & VID_TYPE_MONOCHROME) fmt=VIDEO_PALETTE_GREY;
	if (ioctl (dev, VIDIOCGMBUF, &vid_buf) == -1) {
		fprintf(stderr, "no mmap falling back on read\n");
		if (ioctl (dev, VIDIOCGWIN, &vid_win)== -1) {
			perror ("ioctl VIDIOCGWIN");
			return (NULL);
		}
		vid_win.width=width;
		vid_win.height=height;
		if (ioctl (dev, VIDIOCSWIN, &vid_win)== -1) {
			perror ("ioctl VIDIOCSWIN");
			return (NULL);
		}
		read_img=1;
		map=malloc(width*height*3);
		return (map);
	}
	/* If we are going to capture greyscale we need room to blow the image up */
	if (fmt==VIDEO_PALETTE_GREY)
		map=mmap(0, vid_buf.size*3, PROT_READ|PROT_WRITE, MAP_SHARED, dev, 0);
	else
		map=mmap(0, vid_buf.size, PROT_READ|PROT_WRITE, MAP_SHARED, dev, 0);

	if ((unsigned char *)-1 == (unsigned char *)map)
		return (NULL);
	return map;
}



char *next_capture (unsigned int dev,unsigned char *map,unsigned int width,unsigned int height)
{
	int i;
	char *grey, *rgb;
	struct video_mmap vid_mmap;

    	sigset_t    set, old;

	if (read_img) {
		if (fmt==VIDEO_PALETTE_GREY) {
			if (read(dev, map, width*height) != width*height)
				return NULL;
		} else {
			if (read(dev, map, width*height*3) != width*height*3)
				return NULL;
		}
	} else {
		vid_mmap.format=fmt;
		vid_mmap.frame=0;
		vid_mmap.width=width;
		vid_mmap.height=height;

        	sigemptyset (&set);	     //BTTV hates signals during IOCTL
	        sigaddset (&set, SIGCHLD);   //block SIGCHLD & SIGALRM
       		sigaddset (&set, SIGALRM);   //for the time of ioctls
        	sigprocmask (SIG_BLOCK, &set, &old);

		if (ioctl(dev, VIDIOCMCAPTURE, &vid_mmap) == -1) {
	        	sigprocmask (SIG_UNBLOCK, &old, NULL);
			return (NULL);
		}
		if (ioctl(dev, VIDIOCSYNC, &vid_mmap) == -1) {
	        	sigprocmask (SIG_UNBLOCK, &old, NULL);
			return (NULL);
		}

        	sigprocmask (SIG_UNBLOCK, &old, NULL); //undo the signal blocking
	}
	/* Blow up a grey */
	if (fmt==VIDEO_PALETTE_GREY) {
		i=width*height;
		grey=map+i-1;
		rgb=map+i*3;
		for (; i>=0; i--, grey--) {
			*(rgb--)=*grey;
			*(rgb--)=*grey;
			*(rgb--)=*grey;
		}
	}
	return map;
}


int filtro_image(unsigned char *image_out,unsigned char *image_new,unsigned int width,unsigned int height)
{
	int i;

	for (i=width*3+3; i<(width-1)*3*(height-3); i=i+3) {
		if ((image_new[i]<SOGLIA_r)&&(image_new[i+1]<SOGLIA_g)&&(image_new[i+2]<SOGLIA_b))
		{
		image_out[i]=0;
		image_out[i+1]=0;
		image_out[i+2]=0;
		} else if ((image_new[i+width*3]<SOGLIA_r)&&(image_new[i+1+width*3]<SOGLIA_g)&&(image_new[i+2+width*3]<SOGLIA_b))
		{
		image_out[i]=0;
		image_out[i+1]=0;
		image_out[i+2]=0;
		} else if ((image_new[i-width*3]<SOGLIA_r)&&(image_new[i+1-width*3]<SOGLIA_g)&&(image_new[i+2-width*3]<SOGLIA_b))
		{
		image_out[i]=0;
		image_out[i+1]=0;
		image_out[i+2]=0;
		} else if ((image_new[i-3]<SOGLIA_r)&&(image_new[i+1-3]<SOGLIA_g)&&(image_new[i+2-3]<SOGLIA_b))
		{
		image_out[i]=0;
		image_out[i+1]=0;
		image_out[i+2]=0;
		} else if ((image_new[i+3]<SOGLIA_r)&&(image_new[i+1+3]<SOGLIA_g)&&(image_new[i+2+3]<SOGLIA_b))
		{
		image_out[i]=0;
		image_out[i+1]=0;
		image_out[i+2]=0;
		} else

		{
		image_out[i]=image_new[i];
		image_out[i+1]=image_new[i+1];
		image_out[i+2]=image_new[i+2];
		}


		}

	return 1;
}



int rileva_quote(unsigned int *quote,unsigned char *image,unsigned int width,  unsigned int height)
{
	unsigned int x,y,i,quote_min,quote_max;
	i=0;

	for (x=3; x<width*3; x=x+3) {


		quote_max=0;
		quote_min=0;

		for (y=1; y<(height-1); y=y+1) {


		if (image[x+y*width*3] != 0 )

			{

			quote_min=y;
			if (quote_max == 0 ) quote_max=y;

			}


		}

	if ((quote_min -quote_max )<120)
	quote[i]=quote_max+(quote_min-quote_max)/2;
	else quote[i]=0;

	i++;

	}


	return 1;
}


int copy_image(unsigned char *image_2,unsigned char *image_1,unsigned int width,unsigned int height)
{
/* copia image1 in image2 */

int i;

i=width*height*3;
	for (; i>=0; i--) 
		image2[i]=image1[i];

}

int noise_less(unsigned char *image_2,unsigned char *image_1,unsigned int width,unsigned int height)
{
/* elimina le differenze tra image1 e image2 e restituisce il risultato in image2 */
/* i pixel con differenza > diff sono =0 */



int i;

	for (i=width*3+3; i<(width-1)*3*(height-3); i=i+3) {
		if (abs(image_1[i]-image_2[i])+abs(image_1[i+1]-image_2[i+1])+abs(image_1[i+2]-image_2[i+2])>DIFFERENZA)
		{
		image_2[i]=0;
		image_2[i+1]=0;
		image_2[i+2]=0;
		} else

		{
		image_2[i]=image_1[i];
		image_2[i+1]=image_1[i+1];
		image_2[i+2]=image_1[i+2];
		}
	}

}

int diff_image(unsigned char *image_2,unsigned char *image_1,unsigned int width,unsigned int height)
{
/* rileva le differenze tra image1 e image2 e restituisce il risultato in image2 */
/* i pixel con differenza < diff sono =0 */

	
int i;

	for (i=width*3+3; i<(width-1)*3*(height-3); i=i+3) {
		if (abs(image_1[i]-image_2[i])+abs(image_1[i+1]-image_2[i+1])+abs(image_1[i+2]-image_2[i+2])<DIFFERENZA)
		{
		image_2[i]=0;
		image_2[i+1]=0;
		image_2[i+2]=0;
		} else

		{
		image_2[i]=image_1[i];
		image_2[i+1]=image_1[i+1];
		image_2[i+2]=image_1[i+2];
		}
	}
	
}


int main (int argc, char **argv)
{
	unsigned int devin;
	unsigned int width;
	unsigned int height;
	unsigned char *image_out, *image_new;
	unsigned int i;
	unsigned int quote [1024];
	unsigned int mm,hh,z, z_max, lunghezza, altezza, punti;

	FILE *filedxf,*fopen();
	FILE *filexyz,*fopen();



for (z=0;z<400;z++)
	for (i=0; i<600; i++) { matrice [z][i] = 0; }


 z=400;
 punti=29;

 filedxf = fopen("tmp/scannerdxf.dxf","a");
    if (filedxf < 0) {
	perror("Cannot open well known file dxf");
	exit(-1);
}

filexyz = fopen("tmp/scannerxyz.xyz","a");
    if (filedxf < 0) {
	perror("Cannot open well known file xyz");
	exit(-1);
}


fprintf (filedxf, "  0\n");
fprintf (filedxf, "SECTION\n");
fprintf (filedxf, "  2\n");
fprintf (filedxf, "ENTITIES\n");
fprintf (filedxf, "  0\n");





	if (argc != 4) {
		printf("Usage:\n");
		printf("\n");
		printf("./miniscanner [input] [larghezzaxaltezza] [widthxheight]\n");
		printf("\n");
		printf("example: ./miniscanner3d /dev/video0 600x100 640x480\n");
		printf("\n");
		exit(1);
	}
	sscanf(argv[3], "%dx%d", &width, &height);
	sscanf(argv[2], "%dx%d", &lunghezza, &altezza);
	
	fprintf (filexyz, " %d %d %d \n",lunghezza,height,altezza);
	
	image_out=malloc(width*height*3* sizeof (unsigned char));
	

	
	

	devin=open (argv[1], O_RDWR);
	if (devin < 0) {
		perror ("Failed to open video device");
		exit(1);
	}

	
	image_new=start_capture (devin, width, height);
	if (!image_new) {
		perror("Capture error");
		exit(1);
	}

	

	next_capture(devin, image_new, width, height);
	

	while (z>altezza) {

		next_capture(devin, image_new, width, height);
		
		/*copy_image(image_out,image_new,width,height);
		next_capture(devin, image_new, width, height);
		noise_less(image_out,image_new,width,height);*/
		
		filtro_image(image_out,image_new,width,height);
		
		rileva_quote(quote,image_out,width,height);
		




	i=0;
	





 hh=0;
 mm=0;
 for (i=5; i<25; i++) {if (quote[i]!=0) {mm++;hh=hh+quote[i];}}
 if (mm!=0) hh=hh/mm; 
 
 if (z!=hh&&hh!=0)
 {
 z=hh; 
 printf ( "z = %d \n",z);
 for (i=0; i<600; i++) { matrice [z][i] = quote[i]; }
}
	}
	
	for (z=0;z<400;z++)
	
		for (i=(width/2)-(lunghezza/2); i<(width/2)+(lunghezza/2); i++) {

		if (matrice[z][i]!=0){
	punti++;
	
	fprintf (filedxf, "POINT\n");
	fprintf (filedxf, "  5\n");
	fprintf (filedxf, "%d\n ",punti);
	fprintf (filedxf, "  8\n");
	fprintf (filedxf, "0\n");
	fprintf (filedxf, " 10\n");
	fprintf (filedxf, "%d\n ",i);
	fprintf (filedxf, " 20\n");
	fprintf (filedxf, "%d\n",matrice[z][i]);
	fprintf (filedxf, " 30\n");
	fprintf (filedxf, "%d\n",z);
	fprintf (filedxf, "  0\n" );
	
	}
	fprintf (filexyz, " %d %d %d \n",i,matrice[z][i],z );
	
	

	

}


	
	close (devin);
	

	

fprintf (filedxf, "ENDSEC\n");
fprintf (filedxf, "  0\n");
fprintf (filedxf, "EOF\n");



fflush(filedxf);
close (filedxf);

fflush(filexyz);
close (filexyz);
	exit(0);



}


